#include "listino.h"



list leggiIngredienti(char *filename)
{
	FILE * fp;
	char nome[MAX];
	float prezzo;
	Ingrediente temp;
	list result = emptyList();

	if ((fp = fopen(filename, "r")) == NULL)
	{
		return result;
	}

	while (fscanf(fp, "%s %f", nome, &prezzo) == 2)
	{
		strcpy(temp.nome, nome);
		temp.prezzo = prezzo;
		result = cons(temp, result);
	}

	fclose(fp);
	return result;
}

int scriviIngredienti(char *filename, list l)
{
	FILE * fp;

	if ((fp = fopen(filename, "w")) == NULL)
	{
		return -1;
	}

	while (!isEmpty(l))
	{
		fprintf(fp, "%s %f\n", head(l).nome, head(l).prezzo);
		l = tail(l);
	}

	fclose(fp);
	return 0;
}


float trovaPrezzo(char *nome, list l)
{
	while (!isEmpty(l))
	{
		if (strcmp(head(l).nome, nome) == 0)
		{
			return head(l).prezzo;
		}
		else
		{
			l = tail(l);
		}
	}
	return -1;
}


list aggiornaPrezzo(list l, char *nome, float nuovoPrezzo)
{
	list temp = l;
	int trovato = 0;
	while (!isEmpty(temp) && !trovato)
	{
		if (strcmp(head(temp).nome, nome) == 0)
		{
			trovato = 1;
			temp->value.prezzo = nuovoPrezzo;
		}
		else
		{
			temp = tail(temp);
		}
	}
	return l;
}



list emptyList()
{
	return NULL;
}

list cons(Ingrediente newValue, list l)
{
	item *temp = (item *)malloc(sizeof(item));
	temp->value = newValue;
	temp->next = l;
	return temp;
}

Ingrediente head(list l)
{
	return l->value;
}

list tail(list l)
{
	return l->next;
}

int isEmpty(list l)
{
	return l == NULL;
}